<template>
  <div>

    <b-card
      no-body
      class="mb-0"
    >
      <b-form
        class="p-2"
        @submit.stop.prevent  
      >
        <div class = "title">
          <h4>Editar detalles de un cliente</h4>
        </div>
        <br>
        <b-alert variant="warning" :show="showAlert">Hay un campo vacio</b-alert>
        <b-alert variant="warning" :show="showAlertRequest">{{errorMessageRequest}}</b-alert>
          <b-form-group
            label="Nombre del cliente"
            label-for="name"
            class="w-50"
          >
            <b-form-input
              id="name"
              
              v-model="formData.name"
              autofocus
              trim
              maxlength="40"
              :state="validationName"
              placeholder="Nombre del cliente..."
            />
            <b-form-invalid-feedback :state="validationName">
                Este campo es obligatorio
            </b-form-invalid-feedback>
                   

                  
          </b-form-group>
          
          <b-form-group
              label="RFC"
              label-for="rfc"
              class="w-50"
            >
              <b-form-input
                id="rfc"
                v-model="formData.rfc"
                autofocus
                trim
                maxlength="13"
                :state="validationRfc"
                placeholder="RFC"
              />
              <b-form-invalid-feedback :state="validationRfc">
                Por favor ingrese un RFC valido, por ejemplo: VECJ880326XXX
              </b-form-invalid-feedback>

                  
          </b-form-group>
           <b-form-group
              label="Moneda de pago"
              label-for="currency"
              class="w-50"
            >
              <v-select
                v-model="formData.currency_type"
                :options="currencyType"
                input-id="currency-type"
                class="payment-selector"
                placeholder="Seleccione una moneda"
                :clearable="false"
              />                
          </b-form-group>

          <div class="d-flex mt-2">
            <b-button

              variant="primary"
              class="mr-2"
              type="submit"
              :disabled="lockedSubmitByName || lockedSubmitByRfc"
              @click="handleSubmit()"
            >
              Guardar
            </b-button>
            <b-button
  
              type="button"
              @click="$router.back()"
              variant="outline-secondary"
           
            >
              Cancelar
            </b-button>
          </div>
      </b-form>
    </b-card>
    


  </div>
</template>

<script>
import {
  BSidebar, BForm, BFormGroup, BFormInput, BFormInvalidFeedback, BButton,BTab, BTabs, BCard, BAlert, BLink,
} from 'bootstrap-vue'
import vSelect from 'vue-select'
export default {
  components: {
    BTab,
    BTabs,
    BCard,
    BAlert,
    BLink,
    BSidebar,
    BForm,
    BFormGroup,
    BFormInput,
    BFormInvalidFeedback,
    BButton,
    vSelect,
 
  },

  data(){
    return{
      formData:{
        name:'',
        rfc:'',
        currency_type:'',
        id:this.$route.params.id,

      },
      showAlert:false,
      showAlertRequest:false,
      hasWrittenName:false,
      hasWrittenRfc:false,
      lockedSubmitByName:false,
      lockedSubmitByRfc:false,
      errorMessageRequest:'',
      currencyType:['MXN' , 'USD',],

    }
  },
  methods:{
    handleSubmit(){

      if(this.formData.name===''){
          this.showAlert=true
          return
      }else{
        this.$swal({
          title: '¿Está seguro de actualizar el registro?',
          text: "Se reemplazarán los datos modificados!",
          icon: 'warning',
          showCancelButton: true,
          confirmButtonText: 'Si, guardar!',
          customClass: {
            confirmButton: 'btn btn-primary',
            cancelButton: 'btn btn-outline-danger ml-1',
          },
          buttonsStyling: false,

        }).then(result => {
          if (result.value) {
            
            this.$http.post('clients/edit',this.formData).then(res =>{
              this.$swal({
                  icon: 'success',
                  title: 'Guardado!',
                  text: 'El registro ha sido actualizado.',
                  customClass: {
                    confirmButton: 'btn btn-success',
                  },
              })
              this.$router.push({ name: 'apps-clients-list' })
            }).catch(err=>{
              if (err.response.status == 422){
                console.log('err')
                
                if (err.response.data.errors.rfc){
                  this.showAlertRequest = true
                  this.errorMessageRequest = err.response.data.errors.rfc[0]
                  console.log(err.response.data.errors.rfc[0])
                }
                if (err.response.data.errors.name){
                  this.showAlertRequest = true
                  this.errorMessageRequest = err.response.data.errors.name[0]
                  console.log(err.response.data.errors.name[0])
                }
              }
            })
            } else {
            this.$swal({
              title: 'Cancelado',
              text: 'El registro esta a salvo :)',
              icon: 'error',
              customClass: {
                confirmButton: 'btn btn-success',
              },
            })
          }
        })
            
      }
    },
    getUserData(){
      this.$http.get('clients/show',{params:{id:this.$route.params.id}}).then(res=>{
        this.formData.name=res.data.client.name
        this.formData.rfc= res.data.client.rfc
        this.formData.currency_type= res.data.client.currency_type
      }).catch(function (error){
        console.log(error)
       
        console.log(error.response.data)

      })
    }
  },
  computed:{
    validationName() {
        if(this.formData.name.length > 0 ){
          this.lockedSubmitByName = false
          return true
        }else{
          this.lockedSubmitByName = true
          return false
        }
       
      },
      validationRfc(){
        
        if (this.formData.rfc !== '') {
          var patt = new RegExp("^[A-Z,Ñ,&]{3,4}[0-9]{2}[0-1][0-9][0-3][0-9][A-Z,0-9]?[A-Z,0-9]?[0-9,A-Z]?$");
          if(patt.test(this.formData.rfc)){
            this.lockedSubmitByRfc = false
            return true
          }else{
            this.lockedSubmitByRfc = true
            return false
          }
        } else {
            this.lockedSubmitByRfc = true
            return false
        }
        
        
      },
  },
  mounted(){
    this.getUserData()
  }

}
</script>

<style>

</style>
